tortoisegit-config-user-pass
=============

- [Information](#information)
- [Install](#install)
- [Flags](#flags)
	- [--user](#user-optional)
	- [--pass](#pass-optional)
	- [--repo-path](#repo-path)
- [License](#license)

#Information

I use tortoisegit. When I clone a repo, and then push to it, tortoisegit asks me for my credentials. Every time I commit and push, I am confronted by these credentials windows. After some research, I found that I can put my username (and password, if I wanted) into a git config file, so when I push to a repo, tortoisegit does not ask for my username (or password, if I put it in).

This is an app to make it easier to add usernames (and passwords, if you want) to git config files.

#Install

- Clone this repo
- Get [node](nodejs.org) if you don't have it
- In cmd/terminal navigate to repo and do `node . [flags]`

##Flags

All the flags are optional. All defaults are specified in `./defaults.json`

No spaces are allowed in the arguments. (E.g. `-r C:/src` is ok, but `-r C:/my src` is not. If you need spaces to be allowed, make an issue, or better yet, a pull request.)

Flags:
- [--user](#user-optional)
- [--pass](#pass-optional)
- [--repo-path](#repopath)

##--user

`-u <username>` or `--user <username>` or `--username <username>`
If this is an empty string or not supplied, the app will automatically use the repo owner as the username. (E.g. The repo: `https://github.com/ArtskydJ/tortoisegit-config-user-pass` would make `ArtskydJ` the username, and the repo: `https://github.com/joyent/node` would make `joyent` the username.) If it is supplied, it will supercede the owner.

#--pass (optional)

`-p <password>` or `--pass <password>` or `--password <password>`
If this is an empty string or not supplied, tortoisegit will still ask you for your password.

##--repo-path

`-r <repoPath>` or `--repo <repoPath>` or `--repo-path <repoPath>`
This is the folder where your repos are stored. Remember, no spaces are allowed!

#License

[MIT](http://opensource.org/licenses/MIT)
