var fs = require('fs')
var path = require('path')
var url = require('url')

var fixConfigFiles = function (options, verbose) {
	var repoPath = options.r
	var user = options.u
	var pass = options.p
	fs.readdirSync(repoPath).forEach(function (repoFolder) {
		verbose>1 && console.log('\n'+repoFolder)
		var filePath, fileData
		filePath = path.resolve(repoPath, repoFolder, '.git', 'config')
		try {
			fileData = fs.readFileSync(filePath, {encoding:'utf8'})
		} catch (err) {
			verbose>1 && console.warn(repoFolder+' does not have a config file')
		} //skip it
		if (fileData) {
			fileData.split(/\s/).filter(function (piece) {
				return (piece.indexOf('http') === 0 || piece.indexOf('git') === 0)
			}).forEach(function (originalUrl) {
				verbose>1 && console.log('Found url: ' + originalUrl)
				var parsedUrl = url.parse( originalUrl )
				if (!parsedUrl.auth) { parsedUrl.auth = '' }
				var urlGithubUser = parsedUrl.pathname.split('/')[1]
				//[Previous line] B/c of the leading slash, [0] will be empty; take [1]

				if (!parsedUrl.auth) {
					var auth = user || urlGithubUser //if original does not have user, add custom user
					if ((!parsedUrl.auth || parsedUrl.auth.indexOf(':') === -1) && pass) {
						auth += ':' + pass //if original does not have password, add custom password
					}
					parsedUrl.auth = auth
					var formattedUrl = url.format(parsedUrl)
					verbose==1 && console.log(repoFolder)
					verbose && console.log(originalUrl + ' -> ' + formattedUrl + '\n')
					var newFileData = fs.readFileSync(filePath, {encoding:'utf8'}) //otherwise multiple url's don't work
					fs.writeFileSync(filePath, newFileData.replace(originalUrl, formattedUrl), {encoding:'utf8'})
				}
			})
		}
	})
}

module.exports = fixConfigFiles //Command Line arguments

//Does not support usernames, passwords, or paths that have spaces in them
