﻿var test = require('tap').test
var fs = require('fs')
var path = require('path')
var argumentParser = require('../argumentParser.js') //stopped using this
var fixConfigFiles = require('../fixConfigFiles.js')

test('test argumentParser.js', function (t) {
	var compare = {
		u: 'ArtskydJ',
		p: 'lolnotthis',
		r: 'C:/src/wat/git/hi'
	}
	var options = argumentParser([
		'-u', compare.u,
		'-p', compare.p,
		'-r', compare.r
	])
	t.equal(options.user, compare.u, 'Correctly parsed the user')
	t.equal(options.pass, compare.p, 'Correctly parsed the password')
	t.equal(options.repoPath, compare.r, 'Correctly parsed the path')
	t.end()
})


test('test fixConfigFiles.js', function (t) {
	var options = {
		u: 'ArtskydJ',
		p: '',
		r: 'C:/Github/tortoisegit-config-user-pass'
	}
	var encodeUtf = {encoding: 'utf8'}
	var copyFrom = path.resolve(options.r,'./test/configTemplate.txt')
	var copyTo = path.resolve(options.r,'./test/.git/config')

	//Copy ./configTemplate.txt file to ./.git/config file (overwrite)
	var configTemplate = fs.readFileSync(copyFrom, encodeUtf)
	fs.writeFileSync(copyTo, configTemplate, encodeUtf)
	var configExpect = configTemplate.replace(/:\/\/github\.com/g, '://'+options.u+'@github.com').split('\n') //lines

	fixConfigFiles(options) //synchronous

	var configResult = fs.readFileSync(copyTo, encodeUtf).split('\n') //lines
	t.plan(configResult.length)
	for(var i=0; i<configResult.length; i++) {
		t.equal(configResult[i], configExpect[i], 'lines '+i+' are the same')
	}
	t.end()
})
